﻿Imports System
Imports System.Web.UI
Imports Infragistics.Web.UI.Framework
Imports Infragistics.Web.UI.Framework.Persistence
Imports Infragistics.Web.UI.GridControls
Imports System.Web.UI.WebControls
Imports System.IO
Imports System.Web

Public Class _Default
	Inherits System.Web.UI.Page

	Protected Sub Page_InitComplete(ByVal sender As Object, ByVal e As EventArgs) Handles Me.InitComplete
		Debug.WriteLine("Page_InitComplete")

	End Sub

	Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		Debug.WriteLine("Page_Load")

		igWHDG.DataSource = MakeTableDataSet(False)
		igWHDG.DataKeyFields = "id"
		igWHDG.DataBind()

		igWDG.DataSource = MakeTable(False)
		igWDG.DataKeyFields = "id"
		igWDG.DataBind()
	End Sub

	Private Shared Function FindControlRecursive(ByVal Root As Control, ByVal ClientId As String) As Control
		If Root.ClientID = ClientId Then Return Root

		For Each Ctl As Control In Root.Controls
			Dim FoundCtl As Control = FindControlRecursive(Ctl, ClientId)
			If FoundCtl IsNot Nothing Then
				Return FoundCtl
			End If
		Next

		Return Nothing
	End Function

	Private Sub ManualLoad()
		Debug.WriteLine("ManualLoad: from --> " & Me.GetPersistenceFilePath())

		Dim data As PersistenceData = Nothing
		Dim filePath As String = Me.GetPersistenceFilePath()
		If Not File.Exists(filePath) Then
			Return
		End If

		Using fileStream As FileStream = File.OpenRead(filePath)
			data = PersistenceData.FromStream(fileStream)
		End Using
		If data Is Nothing Then
			Return
		End If

		Dim manager As PersistenceManager = PersistenceManager.GetInstance()
		For Each controlData As ControlData In data.Controls
			If Not String.IsNullOrEmpty(controlData.ControlId) Then
				Debug.Write("  --> Looking for " & controlData.ControlId & "... ")
				' Load the persisted data for the control
				Dim control As Control = FindControlRecursive(Me, controlData.ControlId)
				If control Is Nothing Then
					Debug.WriteLine("failed to find it!")
				Else
					Debug.WriteLine("found it")
				End If
				manager.LoadControl(control, controlData)
			End If
		Next

    ' reset any filters
    'With igWHDG.GridView
    '	.Behaviors.Filtering.ClearBehaviorColumnInfo()
    '	.Behaviors.Filtering.ColumnFilters.Clear()
    '	.Behaviors.Filtering.ApplyFilter()
    'End With
  End Sub

  Private Sub ManualSave()
    Debug.WriteLine("ManualSave: to --> " & Me.GetPersistenceFilePath())

    Dim manager As PersistenceManager = PersistenceManager.GetInstance()
    Dim data As New PersistenceData()

    Debug.WriteLine("  --> Saving control id# " & Me.igWDG.ClientID)
    data.Controls.Add(manager.SaveControl(Me.igWDG, Me.igWDG.ClientID))
    Debug.WriteLine("  --> Saving control id# " & Me.igWHDG.ClientID)
    data.Controls.Add(manager.SaveControl(Me.igWHDG, Me.igWHDG.ClientID))

    Dim filePath As String = Me.GetPersistenceFilePath()
    If File.Exists(filePath) Then
      File.Delete(filePath)
    End If

    Dim directory As String = Path.GetDirectoryName(filePath)
    If Not IO.Directory.Exists(directory) Then
      IO.Directory.CreateDirectory(directory)
    End If

    Debug.WriteLine("  --> to " & filePath)

    Using fileStream As FileStream = File.Create(filePath)
      data.ToStream(fileStream)
    End Using
  End Sub

  Private Function GetPersistenceFilePath() As String
    Dim filePath As String = Server.MapPath("~\Temp\")
    'Dim userName As String = If((HttpContext.Current.User.Identity.IsAuthenticated), HttpContext.Current.User.Identity.Name, _userIPAdress)
    'Dim fileName As String = [String].Format("{0}_{1}", userName.Replace("\"c, "."c).Replace(":", "_"), Me.[GetType]().FullName)
    Dim fileName As String = Me.igWHDG.ID
    Return [String].Format("{0}{1}.xml", filePath, fileName)
  End Function

  Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSave.Click
    ManualSave()
  End Sub

  Protected Sub btnLoad_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnLoad.Click
    ManualLoad()
  End Sub

  Protected Sub btnGrouping_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnGrouping.Click
    If igWHDG.GroupingSettings.EnableColumnGrouping = Infragistics.Web.UI.DefaultableBoolean.True Then
      igWHDG.GroupingSettings.EnableColumnGrouping = Infragistics.Web.UI.DefaultableBoolean.False
    Else
      igWHDG.GroupingSettings.EnableColumnGrouping = Infragistics.Web.UI.DefaultableBoolean.True
    End If

  End Sub

  Protected Sub btnFiltering_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnFiltering.Click
    With igWHDG
      'Dim AFiltering As Infragistics.Web.UI.GridControls.Filtering = .Behaviors.Filtering
      'If AFiltering Is Nothing Then
      '	.Behaviors.Add(.Behaviors.CreateBehavior(Of Infragistics.Web.UI.GridControls.Filtering)())
      '	.Behaviors.Filtering.Enabled = True
      'Else
      '	.Behaviors.Filtering.Enabled = False
      '	.Behaviors.Remove(AFiltering)
      'End If

      .GridView.Behaviors.Filtering.ClearBehaviorColumnInfo()
      .GridView.Behaviors.Filtering.ColumnFilters.Clear()
      .GridView.Behaviors.Filtering.ApplyFilter()

      .Behaviors.Filtering.Enabled = Not .Behaviors.Filtering.Enabled

      '.Behaviors.ColumnMoving.Enabled = Not .Behaviors.ColumnMoving.Enabled
      '.Behaviors.ColumnResizing.Enabled = Not .Behaviors.ColumnResizing.Enabled

      .RefreshBehaviors()
    End With

    With igWDG

      .Behaviors.Filtering.ColumnFilters.Clear()
      .Behaviors.Filtering.Enabled = Not .Behaviors.Filtering.Enabled
    End With
  End Sub

  Protected Sub btnRows_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnRows.Click
    Debug.WriteLine("btnRows_Click")
    Debug.WriteLine("  --> # selected heirgrid rows = " & igWHDG.GridView.Behaviors.Selection.SelectedRows.Count)
    Debug.WriteLine("  --> # selected datagrid rows = " & igWDG.Behaviors.Selection.SelectedRows.Count)

    Dim activeRow As ContainerGridRecord
    activeRow = Me.igWHDG.GridView.Behaviors.Activation.ActiveCell.Row

    For i As Integer = 0 To activeRow.Items.Count - 1
      Dim aCol As GridField = activeRow.Items(i).Column
      Dim aItem As GridRecordItem = activeRow.Items(i)
      Debug.WriteLine("  Item #" & i & ": Col Key = " & aCol.Key & ", Value = " & aItem.Value)

    Next i

    Dim aItem2 As GridRecordItem = activeRow.Items.FindItemByKey("id")
    Debug.WriteLine("Active Row = " & aItem2.Value)
  End Sub

  'Private Sub DataGrid1_RowSelectionChanged(ByVal sender As Object, ByVal e As Infragistics.Web.UI.GridControls.SelectedRowEventArgs) Handles HierDataGrid1.RowSelectionChanged
  '	Debug.WriteLine("DataGrid1_RowSelectionChanged")
  '	Debug.WriteLine("  --> # selected heirgrid rows = " & HierDataGrid1.GridView.Behaviors.Selection.SelectedRows.Count)
  '	Debug.WriteLine("  --> # selected datagrid rows = " & WebDataGrid1.Behaviors.Selection.SelectedRows.Count)

  'End Sub

  'Private Sub WebDataGrid1_RowSelectionChanged(ByVal sender As Object, ByVal e As Infragistics.Web.UI.GridControls.SelectedRowEventArgs) Handles WebDataGrid1.RowSelectionChanged
  '	Debug.WriteLine("WebDataGrid1_RowSelectionChanged")
  '	Debug.WriteLine("  --> # selected heirgrid rows = " & HierDataGrid1.Behaviors.Selection.SelectedRows.Count)
  '	Debug.WriteLine("  --> # selected datagrid rows = " & WebDataGrid1.Behaviors.Selection.SelectedRows.Count)

  'End Sub
  Protected Sub DoClear()
		With igWDG

			.ClearDataSource()
			.Templates.Clear()
			.Behaviors.Sorting.SortedColumns.Clear()
			.Behaviors.Filtering.ClearBehaviorColumnInfo()
			.Behaviors.Filtering.ColumnFilters.Clear()
			'.Behaviors.Filtering.ApplyFilter()

			.ResetToDefault()
		End With

    With igWHDG
			.GroupingSettings.GroupedColumns.Clear()
			.GroupingSettings.ColumnSettings.Clear()
			.ClearTemplates()
			''.GroupingSettings.EnableColumnGrouping = False

			''	.TemplateControl.Dispose()
			.GroupingSettings.EnableColumnGrouping = Infragistics.Web.UI.DefaultableBoolean.False
			.DataSource = MakeTable(True)
			.DataSource = Nothing
			''.DataKeyFields = ""
			.DataBind()
			.GridView.ResetToDefault()
      With .GridView
				.Band.GroupingSettings.GroupedColumns.Clear()
				.Band.GroupingSettings.ColumnSettings.Clear()

				.ClearDataSource()
				.DataBind()
				.Behaviors.Sorting.SortedColumns.Clear()
				'.Rows.Clear()
				.Behaviors.Filtering.ClearBehaviorColumnInfo()
				.Behaviors.Filtering.ColumnFilters.Clear()
				'.Behaviors.Filtering.ApplyFilter()

				.ResetToDefault()
      End With

			.RefreshBehaviors()
    End With

  End Sub

  Protected Sub btnClrFilters_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnClrFilters.Click
		DoClear()
  End Sub

	Private Function MakeTableDataSet(ByVal isEmpty As Boolean) As DataSet
		Dim dataSet As DataSet = New DataSet
		dataSet.Tables.Add(MakeTable(isEmpty))
		Return dataSet
	End Function

	Private Function MakeTable(ByVal isEmpty As Boolean) As DataTable
		' Create a new DataTable.
		Dim table As System.Data.DataTable = New DataTable("Table")
		Dim column As DataColumn
		Dim row As DataRow

		' Create new DataColumn, set DataType, 
		' ColumnName and add to DataTable.    
		column = New DataColumn()
		column.DataType = System.Type.[GetType]("System.Int32")
		column.ColumnName = "id"
		column.[ReadOnly] = True
		' Add the Column to the DataColumnCollection.
		table.Columns.Add(column)

		' Create second column.
		column = New DataColumn()
		column.DataType = System.Type.[GetType]("System.String")
		column.ColumnName = "Item"
		column.AutoIncrement = False
		column.Caption = "Item"
		column.[ReadOnly] = False
		column.Unique = False
		table.Columns.Add(column)

		' Create third column.
		column = New DataColumn()
		column.DataType = System.Type.[GetType]("System.String")
		column.ColumnName = "Data"
		column.AutoIncrement = False
		column.Caption = "Data"
		column.[ReadOnly] = False
		column.Unique = False
		' Add the column to the table.
		table.Columns.Add(column)

		' Create third column.
		column = New DataColumn()
		column.DataType = System.Type.[GetType]("System.String")
		column.ColumnName = "Group"
		column.AutoIncrement = False
		column.Caption = "Group"
		column.[ReadOnly] = False
		column.Unique = False
		' Add the column to the table.
		table.Columns.Add(column)

		' Make the ID column the primary key column.
		Dim PrimaryKeyColumns As DataColumn() = New DataColumn(0) {}
		PrimaryKeyColumns(0) = table.Columns("id")
		table.PrimaryKey = PrimaryKeyColumns

		If Not isEmpty Then
			For i As Integer = 0 To 20



				row = table.NewRow()
				row("id") = i
				row("Item") = "Item " & i
				row("Data") = "Data " & i
				row("Group") = "Group " & IIf(i < 10, "One", "Two")
				table.Rows.Add(row)
			Next
			Return table
			End If
		Return table

	End Function

End Class